SystemOrganization addCategory: #'Path-Spike-AcceptIt'!
SystemOrganization addCategory: #'Path-Spike-ObjectView'!
SystemOrganization addCategory: #'Path-Spike-Record-Replay'!
SystemOrganization addCategory: #'Path-Spike-StateView'!

MwMethodWrapper subclass: #SRecordReplayWrapper
	instanceVariableNames: 'replayCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SRecordReplayWrapper class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:36'!
on: aSymbol inClass: aClass with: aReplayCache
	
	^ (self on: aSymbol inClass: aClass)
		replayCache: aReplayCache;
		yourself! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache
	"Answer the value of replayCache"

	^ replayCache! !

!SRecordReplayWrapper methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:36'!
replayCache: anObject
	"Set the value of replayCache"

	replayCache := anObject! !

!SRecordReplayWrapper methodsFor: 'evaluating' stamp: 'mp 5/18/2010 11:41'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| record result |
	record := self replayCache 
		at: (MethodReference class: self wrappedClass selector: self clientSelector) 
		receiver: anObject 
		arguments: anArrayOfObjects.
	record ifNotNil: [^ record recordedResult].
	self beforeMethod.
	^ [	result := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
		self replayCache 
			at: (MethodReference class: self wrappedClass selector: self clientSelector) 
			receiver: anObject 
			arguments: anArrayOfObjects
			put: result.
		result
	] ensure: [self afterMethod]! !

Object subclass: #SReplayCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:15.942'!
at: aMethodReference receiver: anObject arguments: aCollection
	| record |
	record := self cache 
				at: (SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection) 
				ifAbsent: [nil].
	record ifNotNil: [
		(record receiver = anObject and: [record arguments = aCollection])
			ifFalse: [record := nil]
		].
	^ record! !

!SReplayCache methodsFor: 'public API' stamp: 'mp 7/7/2010 16:58:19.13'!
at: aMethodReference receiver: anObject arguments: aCollection put: aResult
	| record |
	self flag: #mpe. "Refactor me!!!!!!"
	record := SReplayRecord method: aMethodReference receiver: anObject arguments: aCollection result: aResult.
	self cache 
		at: record 
		put: record.
	! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache
	"Answer the value of cache"

	^ cache! !

!SReplayCache methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:24'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!SReplayCache methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:24'!
initialize

	self cache: Dictionary new.! !

Object subclass: #SReplayRecord
	instanceVariableNames: 'methodReference receiver arguments recordedResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-Record-Replay'!

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 12:02'!
method: aMethodReference receiver: anObject arguments: aCollection

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		yourself! !

!SReplayRecord class methodsFor: 'instance creation' stamp: 'mp 5/18/2010 11:54'!
method: aMethodReference receiver: anObject arguments: aCollection result: aResult

	^ self new
		methodReference: aMethodReference;
		receiver: anObject;
		arguments: aCollection;
		recordedResult: aResult;
		yourself! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:58'!
= anObject

	self class == anObject class ifFalse: [^ false].
	^ ((anObject methodReference = self methodReference) 
		and: 	[anObject receiver = self receiver]) 
		and: [anObject arguments = self arguments]! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!SReplayRecord methodsFor: 'comparing' stamp: 'mp 5/18/2010 11:59'!
hash

	^ (self methodReference hash bitXor: self receiver hash) bitXor: self arguments hash! !

!SReplayRecord methodsFor: 'initialize-release' stamp: 'mp 5/18/2010 11:23'!
initialize

	self arguments: #().! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference
	"Answer the value of methodReference"

	^ methodReference! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:55'!
methodReference: anObject
	"Set the value of methodReference"

	methodReference := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult
	"Answer the value of recordedResult"

	^ recordedResult! !

!SReplayRecord methodsFor: 'accessing' stamp: 'mp 5/18/2010 11:23'!
recordedResult: anObject
	"Set the value of recordedResult"

	recordedResult := anObject! !

STool subclass: #SPMScenarioStepsDisplay
	instanceVariableNames: 'scenario result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-AcceptIt'!

!SPMScenarioStepsDisplay class methodsFor: 'as yet unclassified' stamp: 'mp 4/4/2011 17:51:06.773'!
listForParseTree: aParseTree
	
	| pureTree verbTree list max |
	max := 0.
	"format tests"
	(aParseTree first ~= #annotated) ifTrue: [^ {}].
	pureTree := aParseTree second.
	(pureTree first ~= #scenario) ifTrue: [^ {}].
	(pureTree second first ~= #title) ifTrue: [^ {}].
	"actual."
	verbTree := pureTree allButFirst: 2.
	verbTree do: [ :verbArray |
		verbArray allButFirst do: [:assoc | 
			max := max max: assoc key]].
	list := Array new: max.
	verbTree do: [ :verbArray | | verb |
		verb := verbArray first.
		verbArray allButFirst do: [:assoc | 
			list at: assoc key put: verb -> assoc value]].

	^ list! !

!SPMScenarioStepsDisplay class methodsFor: 'instance creation' stamp: 'mp 4/4/2011 16:32:50.188'!
openOn: aMethodReference and: aTestResult

	^ self open
		scenario: aMethodReference;
		result: aTestResult;
		refresh;
		yourself! !

!SPMScenarioStepsDisplay methodsFor: 'building' stamp: 'mp 4/4/2011 17:35:18.956'!
buildSelectionListOn: aBuilder
	| listSpec |
	listSpec := SPluggableMultiSelectionListSpec new
		model: self;
		name: #steps;
		list: #stepsOfScenario;
		itemColor: #stepColorAt:;
		getSelectionList: #stepSelectedAt:;
		setSelectionList: #stepSelectedAt:put:;
		frame: (0.0 @ 0.0 corner: 1.0 @ 1.0);
		yourself.
	self windowSpec children add: listSpec.! !

!SPMScenarioStepsDisplay methodsFor: 'building' stamp: 'mp 4/4/2011 16:38:06.044'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildSelectionListOn: aBuilder.

	^ super buildWith: aBuilder
! !

!SPMScenarioStepsDisplay methodsFor: 'user interface' stamp: 'mp 4/4/2011 16:44:47.239'!
initialExtent

	^ 500@150! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 16:34:07.085'!
label

	self scenario ifNil: [^ ''].
	^ self scenario actualClass asString, ' - ', self scenario methodSymbol asString! !

!SPMScenarioStepsDisplay methodsFor: 'updating' stamp: 'mp 4/4/2011 16:44:15.958'!
refresh
	
	self 
		changed: #label;
		changed: #stepsOfScenario.! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 16:27:03.236'!
result
	"Answer the value of result"

	^ result! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 16:27:03.251'!
result: anObject
	"Set the value of result"

	result := anObject! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 16:27:03.206'!
scenario
	"Answer the value of scenario"

	^ scenario! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 16:27:03.222'!
scenario: anObject
	"Set the value of scenario"

	scenario := anObject! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 17:46:38.525'!
scenarioCode
	^ self scenarioInstance testMethodSource asString! !

!SPMScenarioStepsDisplay methodsFor: 'accessing' stamp: 'mp 4/4/2011 17:44:20.811'!
scenarioInstance
	^ self scenario actualClass selector: self scenario methodSymbol! !

!SPMScenarioStepsDisplay methodsFor: 'spec commands' stamp: 'mp 4/4/2011 17:59:10.598'!
stepColorAt: anIndex
	| stepStatus code parser sourceId |
	self result ifNil: [^ Color black].
	stepStatus := result stepStatus at: result stepStatus keys first.
	code := self scenarioCode.
	parser := [ACUSAnnotatedParser scenarioParseTree: code readStream] 
				on: OM2Fail do: [^ Color black].
	sourceId := (self class listForParseTree: parser) at: anIndex ifAbsent: [^ Color black].
	(stepStatus at: sourceId  ifAbsent: [#default]) caseOf:  {
		[#default] -> [^ Color black].
		[#passed] -> [^ Color green muchDarker].
		[#failed] -> [^ Color yellow muchDarker].
		[#error] -> [^ Color red]}! !

!SPMScenarioStepsDisplay methodsFor: 'spec commands' stamp: 'mp 4/4/2011 16:52:58.298'!
stepSelectedAt: anIndex

	^ false! !

!SPMScenarioStepsDisplay methodsFor: 'spec commands' stamp: 'mp 4/4/2011 17:44:11.829'!
stepSelectedAt: anIndex put: aBoolean

	|  step parsedScenario linesWithPrefix |
	anIndex <= 2 ifTrue: [^ self].
	parsedScenario := ACUSParser 
						matchAll: self scenario compiledMethod getSource readStream 
						with: #scenario withArgs: #().
	linesWithPrefix := OrderedCollection new.
	(parsedScenario allButFirst: 2) do: [:each | 
		each do: [:item | item isSymbol 
							ifFalse: [linesWithPrefix add: {each first. item}]]]. 
	
	step := self scenarioInstance
		methodForVerb: ((linesWithPrefix at: anIndex - 2) first)
		andStep:  ((linesWithPrefix at: anIndex - 2) second) asString.
	
	self systemNavigation 
		browseAllImplementorsOf: step selector 
		localTo: step methodClass .! !

!SPMScenarioStepsDisplay methodsFor: 'spec commands' stamp: 'mp 4/4/2011 17:46:59.149'!
stepsOfScenario
	self scenario ifNil: [^ #()].
	^ self scenarioCode lines! !

STool subclass: #SPathObjects
	instanceVariableNames: 'objectViewMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-ObjectView'!

!SPathObjects class methodsFor: 'as yet unclassified' stamp: 'mp 1/31/2013 17:34:03.603'!
openOn: aCallgraphModel

	^ self new
		createObjectViewWith: aCallgraphModel;
		yourself! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2013 14:43:19.784'!
buildButtonsWith: aBuilder
	self
		buildButtonsPanelWith: aBuilder
		from: self toolbarButtons
		model: self objectViewMorph
		frame: (0.0 @ 0.0 corner: 1 @ 0.05).! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2013 14:47:33.617'!
buildWindowWith: aBuilder
	| viewSpec |
	self buildWindowOn: aBuilder.
	self windowSpec
		model: self objectViewMorph;
		label: #windowLabel;
		closeAction: nil.
	viewSpec :=  SPathViewDiagramSpec new
							model: self;
							children: OrderedCollection new;
							frame: (0@0.05 extent: 1@0.95);
							viewAreaMorph: self objectViewMorph.
	self windowSpec children addAll: { viewSpec }.
	self buildButtonsWith: aBuilder.
	super buildWith: aBuilder.! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2013 14:44:59.982'!
buildWith: aBuilder 
	
	self
		buildWindowWith: aBuilder;
		resizeWindow.
	^ self windowMorph! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 1/31/2013 17:36:23.37'!
createObjectViewWith: aCallgraphModel

	self objectViewMorph: (SObjectView on: aCallgraphModel).
	ToolBuilder open: self.! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 1/31/2013 17:42:16.427'!
initialExtent

	^ 500@500! !

!SPathObjects methodsFor: 'accessing' stamp: 'mp 1/31/2013 17:33:02.433'!
objectViewMorph
	"Answer the value of objectViewMorph"

	^ objectViewMorph! !

!SPathObjects methodsFor: 'accessing' stamp: 'mp 1/31/2013 17:33:02.445'!
objectViewMorph: anObject
	"Set the value of objectViewMorph"

	objectViewMorph := anObject! !

!SPathObjects methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2013 14:49:17.949'!
toolbarButtons
	^ #(
		('I<<' #TODO #alwaysEnabled)
		('<<'  #TODO #alwaysEnabled)
		('>>'  #nextCall #alwaysEnabled)
		('>>I' #constructView #alwaysEnabled))! !

STracer subclass: #SStateViewTracer
	instanceVariableNames: 'observedClass instVarName valueDict gatheredValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-StateView'!

!SStateViewTracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:07:53.882'!
onClass: aClass instVarName: aSymbol
	^ (super 
		on: SProject current 
		entryPoints: (SProject current allTestsAsEntryPoints))
		observedClass: aClass;
		instVarName: aSymbol;
		yourself! !

!SStateViewTracer methodsFor: 'wrapper events' stamp: 'mp 9/29/2010 22:41:40.35'!
addValue: anObject

	self gatheredValues add: anObject.! !

!SStateViewTracer methodsFor: 'running' stamp: 'mp 9/29/2010 22:45:30.73'!
endExecutionOf: anEntryPoint withResult: anObject

	self gatheredValues ifNotEmpty: [
		self valueDict 
			at: anEntryPoint
			put: self gatheredValues].
	self reset.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.161'!
gatheredValues
	"Answer the value of gatheredValues"

	^ gatheredValues! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.166'!
gatheredValues: anObject
	"Set the value of gatheredValues"

	gatheredValues := anObject! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:52:01.306'!
getWrapperClass

	^ SStateWrapper! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:23:25.775'!
getWrapperOn: aSelector inClass: aClass
	((aClass whichSelectorsAccess: self instVarName) includes: aSelector)
		ifTrue: [	^ self getWrapperClass on: aSelector inClass: aClass with: self]
		ifFalse: [^ nil]! !

!SStateViewTracer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 22:39:31.28'!
initialize
	super initialize.
	self valueDict: Dictionary new.
	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.497'!
instVarName
	"Answer the value of instVarName"

	^ instVarName! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.501'!
instVarName: anObject
	"Set the value of instVarName"

	instVarName := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.809'!
observedClass
	"Answer the value of observedClass"

	^ observedClass! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.814'!
observedClass: anObject
	"Set the value of observedClass"

	observedClass := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:47.398'!
reset

	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:58:58.701'!
selectedClasses

	^ {self observedClass}! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.472'!
valueDict
	"Answer the value of valueDict"

	^ valueDict! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.476'!
valueDict: anObject
	"Set the value of valueDict"

	valueDict := anObject! !

!SStateViewTracer methodsFor: 'public api' stamp: 'mp 9/30/2010 10:46:18.705'!
valuesAsSet
	| resultSet |
	resultSet := Set new.
	self valueDict valuesDo: [:coll | 
		coll do: [:each | resultSet add: each]].
	^ resultSet sorted! !

NCCurveMorph subclass: #SObjectMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-ObjectView'!

!SObjectMorph methodsFor: 'as yet unclassified' stamp: 'mp 1/30/2013 15:18:16.972'!
initializeWithContours: contours
	| font | 
	super initializeWithContours: contours.
	self 
		extent: 50@50;
		layoutInset: 2@2.
	font := Preferences windowTitleFont.
	submorphs first
		fontName: font name pointSize: 5;
		centered.
	submorphs first text removeAttribute: TextEmphasis bold.! !

SPasteUpMorph subclass: #SObjectView
	instanceVariableNames: 'callgraph objects currentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-ObjectView'!

!SObjectView class methodsFor: 'constants' stamp: 'mp 1/30/2013 13:57:17.101'!
distanceBetweenMorphs

	^ 100! !

!SObjectView class methodsFor: 'instance creation' stamp: 'mp 2/1/2013 14:48:26.752'!
on: aCallgraphModel
	| objectView |
	objectView := self new
					callgraph: aCallgraphModel;
					yourself.
	^ objectView! !

!SObjectView methodsFor: 'spec commands' stamp: 'mp 2/1/2013 14:45:41.925'!
alwaysEnabled

	^true! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 1/30/2013 13:42:04.78'!
callgraph
	"Answer the value of callgraph"

	^ callgraph! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 1/30/2013 13:42:04.792'!
callgraph: anObject
	"Set the value of callgraph"

	callgraph := anObject! !

!SObjectView methodsFor: 'as yet unclassified' stamp: 'mp 1/30/2013 14:08:12.461'!
constructView
	self
		identifyObjects;
		createMorphsForObjects;
		createCallConnections.! !

!SObjectView methodsFor: 'as yet unclassified' stamp: 'mp 2/1/2013 14:30:49.433'!
createCallConnections
	| identity callIdentity |
	self callgraph traverseCallGraph: self callgraph rootNode with: [:node | 
		identity := node views at: #identities ifAbsent: [nil].
		identity ifNotNil: [
			node nextCalls do: [:call | 
				callIdentity := call views at: #identities ifAbsent: [nil].
				callIdentity ifNotNil: [
				(NCAAConnectorMorph 
					fromMorph: (self objects at: identity) 
					toMorph: (self objects at: callIdentity))
						makeForwardArrow;
						addLabel: call clientSelector near: 10@10;
						"beOrthogonal: true;"
						beSmoothCurve]]]].! !

!SObjectView methodsFor: 'as yet unclassified' stamp: 'mp 1/30/2013 15:21:33.704'!
createMorphsForObjects
	| morph objectsPerLine | 
	objectsPerLine := self width // self class distanceBetweenMorphs.
	self objects keys withIndexDo: [:each :index | 
		morph := SObjectMorph 
					withContours: SObjectMorph circleContours 
					named: (self objects at: each) asString, String cr, each.
		self addMorph: morph.
		morph position: (self position x + 
			(self class distanceBetweenMorphs * (index \\ objectsPerLine))) @ 
						(self position y + 
			(self class distanceBetweenMorphs * (index // objectsPerLine))).
		morph name: each asString.
		self objects at: each put: morph].! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 2/1/2013 14:51:17.86'!
currentNode
	"Answer the value of currentNode"

	^ currentNode ifNil: [currentNode := self callgraph rootNode]! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 2/1/2013 14:50:49.529'!
currentNode: anObject
	"Set the value of currentNode"

	currentNode := anObject! !

!SObjectView methodsFor: 'as yet unclassified' stamp: 'mp 1/30/2013 15:20:50.957'!
identifyObjects
	| id receiver |
	self callgraph traverseCallGraph: self callgraph rootNode with: [:node | 
		id := node views at: #identities ifAbsent: [].
		receiver := node views at: #receiver ifAbsent: [].
		self objects at: id put: receiver].! !

!SObjectView methodsFor: 'initialization' stamp: 'mp 1/31/2013 18:00:41.128'!
initialize
	super initialize.
	self 
		extent: 500@500;
		color: Color white;
		borderColor: Color gray.! !

!SObjectView methodsFor: 'spec commands' stamp: 'mp 2/1/2013 15:12:49.55'!
nextCall
	
	| id |
	id := self currentNode views at: #identities ifAbsent: [nil].
	id 
		ifNil: [self 
				nextNode;
				nextCall]
		ifNotNil: []
	! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 1/30/2013 13:50:27.529'!
objects
	"Answer the value of objects"

	^ objects ifNil: [objects := Dictionary new]! !

!SObjectView methodsFor: 'accessing' stamp: 'mp 1/30/2013 13:50:16.378'!
objects: anObject
	"Set the value of objects"

	objects := anObject! !

!SObjectView methodsFor: 'spec commands' stamp: 'mp 1/31/2013 17:39:55.711'!
windowLabel

	^ 'PathObjects'! !

SWrapper subclass: #SPMActivateTracerIfWhenStepWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-AcceptIt'!

!SPMActivateTracerIfWhenStepWrapper methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 15:03:52.671'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self beforeMethod.
	^ [	anArrayOfObjects first = #when
			ifTrue: [self tracer activate]
			ifFalse: [self tracer deactivate].
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod]! !

SWrapper subclass: #SStateWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Spike-StateView'!

!SStateWrapper methodsFor: 'evaluating' stamp: 'mp 9/30/2010 10:41:22.998'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."
	| value |
	self beforeMethod.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod.
			value := anObject instVarNamed: self tracer instVarName.
			value isLiteral
				ifTrue: [self tracer addValue: value copy]
				ifFalse: [self tracer addValue: value asString]]! !
